﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WpfApp1_drives.BL
{
    class DirectoryLogic : IDirectoryLogic
    {
        IEntrySelectorService service;
        public DirectoryLogic(IEntrySelectorService service) // Dependency Injection!
        {
            this.service = service;
        }

        public IEnumerable<DirectoryEntry> CollectDirectoryEntries(string currentDirectory)
        {
            var entries = new List<DirectoryEntry>();
            if (string.IsNullOrEmpty(currentDirectory))
            {
                // DriveInfo.GetDrives().ToList().ForEach(x => entries.Add(new DirectoryEntry(x.Name, true)));
                foreach (DriveInfo akt in DriveInfo.GetDrives())
                {
                    entries.Add(new DirectoryEntry(akt.Name, true));
                }
            }
            else
            {
                try
                {
                    // Directory.GetDirectories(currentDirectory).ToList().ForEach(x => entries.Add(new DirectoryEntry(x, true)));
                    // Directory.GetFiles(currentDirectory).ToList().ForEach(x => entries.Add(new DirectoryEntry(x, false)));
                    foreach (string subDir in Directory.GetDirectories(currentDirectory))
                    {
                        entries.Add(new DirectoryEntry(subDir, true));
                    }
                    foreach (string file in Directory.GetFiles(currentDirectory))
                    {
                        entries.Add(new DirectoryEntry(file, false));
                    }
                }
                catch (UnauthorizedAccessException) { } // ???
            }
            return entries;
        }

        public void SelectEntry(DirectoryEntry entry)
        {
            service.SelectEntry(entry); 
            // Extracted into a separated interface+class
            // To avoid the BL=>Window/MessageBox/Process dependency
            // This way, this dependency can be mocked
            // This is the ideal way
        }
    }
}
